<?php
// This is included in $oVIP->login function when LDAP module is installed and configured
// This part will validate $username/$password (using a ldap bind)
// and add a new profile (when profile not yet existing)

include 'qtfm_ldap_lib.php';
$bLdapLogin = qtfm_ldap_bind($username,$password);
if ( $bLdapLogin )
{
  $this->auth = true;
  // add profile if new user
  $iProfile = cVIP::SysCount('members',' AND name="'.$username.'" AND pwd="'.sha1($password).'"'); // check profile is created
  if ( $iProfile==0 )
  {
  qtfm_ldap_profile($username,$password); // create new profile (will search email from ldap)
  }
}
else
{
  $this->auth = false;
  // ABORD login when bind failed if authority is configured with ldap ONLY
  if ( isset($_SESSION[QT]['m_ldap_users']) && $_SESSION[QT]['m_ldap_users']=='ldap' ) return false;
}