<?php

// QuickTalk 3.0 build:20121228
// Script added in qtf_form_edit.php when rss is activated.

function ToXml($str)
{
  $str = html_entity_decode($str,ENT_QUOTES);
  if ( strstr($str,'&') ) $str = QTencode($str,'-A -Q -L -R -&');
  $str = str_replace(chr(160),' ',$str); // required for xml
  $str = QTencode($str,'& L R'); // required for xml
  return $str;
}

function MakeRss($s=-1)
{

// check
if ( $_SESSION[QT]['m_rss']!='1' ) Return false;
if ( $s<0 ) die('MakeFeeds: Wrong section');

global $oDB,$L;

// read section info
$oSEC = new cSection($s);

if ( $oSEC->type!=0 ) Return false;

$arr = explode(' ',$_SESSION[QT]['m_rss_conf']);
$top = $arr[2];

// search new topics
$strState = 't.*,p.title,p.textmsg ';
$strState .= 'FROM '.TABTOPIC.' t INNER JOIN '.TABPOST.' p ON t.firstpostid = p.id ';
$strState .= "WHERE t.forum = $s ";
$strOrder = 't.lastpostdate DESC';
$strQ = LimitSQL($strState,$strOrder,0,$top);
$oDB->Query($strQ);
$i=0;
while ($row = $oDB->Getrow())
{
  $item[$i]['title'] = ToXml($row['title']);
  $item[$i]['link'] = $_SESSION[QT]['site_url']."/qtf_item.php?t=".$row['id']."&amp;p=".$row['firstpostid'];

  // format the RSS text
  $item[$i]['description'] = ToXml(QTcompact(QTunbbc($row['textmsg']),400,' '));
  $item[$i]['pudDate'] = $row['lastpostdate'];
  $item[$i]['author'] = $row['firstpostname'];
  $i++;
}

// write rss 2.0

$strFilename = 'rss/qtf_2_'.$s.'.xml';
if ( file_exists($strFilename) )
{
  if ( !is_writable($strFilename) )
  {
  echo $strFilename,' not writable<br/>';
  return false;
  }
}
$handle = fopen('rss/qtf_2_'.$s.'.xml','w');
fwrite($handle,'<?xml version="1.0" encoding="'.QTF_HTML_CHAR.'" ?><rss version="2.0" xmlns:atom="http://www.w3.org/2005/Atom"><channel>'."\n");
fwrite($handle,'<title>'.ToXml($_SESSION[QT]['site_name'].' - '.$oSEC->name).'</title>');
fwrite($handle,'<link>'.$_SESSION[QT]['site_url'].'/qtf_items.php?s='.$s.'</link>');
fwrite($handle,'<description>'.ToXml($oSEC->descr).'</description>');
fwrite($handle,"<language>".QTF_HTML_LANG."</language>\n");
fwrite($handle,"<generator>QuickTalk ".substr(QTFVERSION,0,3)."</generator>\n");
fwrite($handle,"<managingEditor>{$_SESSION[QT]['admin_email']} (webmaster)</managingEditor>\n");
fwrite($handle,"<category>Troubleticket</category>\n");
fwrite($handle,"<image><url>{$_SESSION[QT]['site_url']}/rss/qtf_logo.gif</url><title>".$_SESSION[QT]['site_name'].' - '.$oSEC->name."</title><link>{$_SESSION[QT]['site_url']}/qtf_items.php?s=$s</link><width>110</width><height>50</height></image>\n");
fwrite($handle,'<atom:link href="'.$_SESSION[QT]['site_url'].'/rss/qtf_2_'.$s.'.xml" rel="self" type="application/rss+xml" />'."\n");
for ($n=0; $n<$i; $n++)
{
fwrite($handle,"<item>\n");
fwrite($handle,"<title>{$item[$n]['title']}</title>\n");
fwrite($handle,"<link>{$item[$n]['link']}</link>\n");
fwrite($handle,"<description>{$item[$n]['description']}</description>\n");
fwrite($handle,"<pubDate>".QTdatestr($item[$n]['pudDate'],'D, d M Y H:i:00 O','')."</pubDate>\n");
fwrite($handle,"<guid>{$item[$n]['link']}</guid>\n");
fwrite($handle,"</item>\n");
}
fwrite($handle,'</channel></rss>');
fclose($handle);

// write atom 1.0

$strFilename = 'rss/qtf_atom_'.$s.'.xml';
if ( file_exists($strFilename) )
{
  if ( !is_writable($strFilename) )
  {
  echo $strFilename,' not writable<br/>';
  return false;
  }
}
$handle = fopen('rss/qtf_atom_'.$s.'.xml','w');
fwrite($handle,'<?xml version="1.0" encoding="'.QTF_HTML_CHAR.'" ?><feed xmlns="http://www.w3.org/2005/Atom">'."\n");
fwrite($handle,'<title>'.ToXml($_SESSION[QT]['site_name'].' - '.$oSEC->name).'</title>');
fwrite($handle,'<link href="'.$_SESSION[QT]['site_url'].'/qtf_items.php?s='.$s.'"/>');
fwrite($handle,'<link href="'.$_SESSION[QT]['site_url'].'/rss/qtf_atom_'.$s.'.xml" rel="self"/>');
fwrite($handle,"<id>{$_SESSION[QT]['site_url']}/qtf_items.php?s=$s</id>\n");
fwrite($handle,"<updated>".QTdatestr(date('Y-m-d H:i:s'),'RFC-3339')."</updated>\n");
fwrite($handle,"<author><name>Webmaster</name><email>{$_SESSION[QT]['admin_email']}</email></author>\n");
fwrite($handle,'<category term="Troubleticket"/>');
fwrite($handle,"<generator>QuickTalk ".substr(QTFVERSION,0,3)."</generator>\n");
fwrite($handle,"<icon>{$_SESSION[QT]['site_url']}/rss/qtf_icon.gif</icon>\n");
fwrite($handle,"<logo>{$_SESSION[QT]['site_url']}/rss/qtf_logo.gif</logo>\n");
for ($n=0; $n<$i; $n++)
{
fwrite($handle,"<entry>\n");
fwrite($handle,"<id>{$item[$n]['link']}</id>\n");
fwrite($handle,"<title>{$item[$n]['title']}</title>\n");
fwrite($handle,"<updated>".QTdatestr($item[$n]['pudDate'],'RFC-3339')."</updated>\n");
fwrite($handle,"<author><name>{$item[$n]['author']}</name></author>\n");
fwrite($handle,"<content>{$item[$n]['description']}</content>\n");
fwrite($handle,'<link href="'.$item[$n]['link'].'"/>');
fwrite($handle,"</entry>\n");
}
fwrite($handle,'</feed>');
fclose($handle);

}

// ----------

MakeRss($s);