<?php

// QuickTalk 3.0 build:20121228
// This is included in qtf_form_edit.php

if ( $_SESSION[QT]['m_antispam']>0 ) // this parametre can be >1
{

  if ( !isset($_SESSION[QT]['m_antispam_conf']) ) GetParam(true,'param="m_antispam_conf"');
  if ( !isset($_SESSION[QT]['m_antispam_count']) ) $_SESSION[QT]['m_antispam_count']=0;

  if ( $_SESSION[QT]['m_antispam_count']>3 ) $error = 'too many rejected messages today, retry tomorrow.';

  $strMAz     = substr($_SESSION[QT]['m_antispam_conf'],0,1);
  $strMVowel  = substr($_SESSION[QT]['m_antispam_conf'],1,1);
  $strMChars  = substr($_SESSION[QT]['m_antispam_conf'],2,1);
  $intMChars  = intval(substr($_SESSION[QT]['m_antispam_conf'],3,1));
  $strMWords  = substr($_SESSION[QT]['m_antispam_conf'],4,1);
  $intMWords  = intval(substr($_SESSION[QT]['m_antispam_conf'],5,1));
  $strMGood   = substr($_SESSION[QT]['m_antispam_conf'],6,1);
  $intMGoods  = intval(substr($_SESSION[QT]['m_antispam_conf'],7,1));
  $strMInsane = substr($_SESSION[QT]['m_antispam_conf'],8,1);
  $intMInsane = intval(substr($_SESSION[QT]['m_antispam_conf'],9,1));
  $strMRepeat = substr($_SESSION[QT]['m_antispam_conf'],10,1);
  $strMIp     = substr($_SESSION[QT]['m_antispam_conf'],11,1);

  // minimum size
  if ( empty($error) && $strMChars=='1' )
  {
    if ( strlen($oPost->text)<=$intMChars ) $error = 'message too short.';
  }

  if ( empty($error) )
  {
  $strM = strtolower(substr($oPost->text,0,500));
  }

  if ( empty($error) && $strMAz=='1' )
  {
    if ( !preg_match("/[a-z]/",$strM) ) $error = 'message suspect, no meaningful characters.';
  }

  if ( empty($error) )
  {
    $strM = strtr($strM,''  ,'eeeeeeee');
    $strM = strtr($strM,'','aaaaaaaaaa');
    $strM = strtr($strM,''  ,'iiiiiiii');
    $strM = strtr($strM,'','oooooooooo');
    $strM = strtr($strM,''  ,'uuuuuuuu');
  }

  // vowels
  if ( empty($error) && $strMVowel=='1' )
  {
    if ( !preg_match("/[aeiouy]/",$strM) ) $error = 'message suspect, no vowels.';
  }

  // check IPs
  if ( empty($error) && $strMIp=='1' )
  {
    include 'avatar/qtfm_ip.php';
    if ( array_key_exists($oDB->ip,$arrIp) ) $error = 'your ip has been locked by the administrator.';
    if ( empty($error) )
    {
    $strMIpGroup = substr($oDB->ip,0,strrpos($oDB->ip,'.')).'*';
    if ( array_key_exists($strMIpGroup,$arrIp) ) $error = 'your ip has been locked by the administrator.';
    }
  }

  if ( empty($error) && $strMWords=='1' )
  {
    $arrMWords = str_word_count($strM,1); // php 4.3.0
    if ( count($arrMWords)<=$intMWords ) $error = 'not enough words.';
  }

  // language
  if ( empty($error) ) {
  if ( $strMGood=='1' || $strMInsane=='1' ) {

    include Translate('qtfm_antispam_goodbad.php');
    if ( $strMGood=='1' )
    {
      if ( !isset($arrMWords) ) $arrMWords = str_word_count($strM,1); // php 4.3.0
      $interMWords = array_intersect($voc['good'],$arrMWords);
      if ( count($interMWords)<=$intMGoods ) $error = 'language not identified.';
    }
    if ( $strMInsane=='1' )
    {
      if ( !isset($arrMWords) ) $arrMWords = str_word_count($strM,1); // php 4.3.0
      $interMWords = array_intersect($voc['bad'],$arrMWords);
      if ( count($interMWords)>=$intMInsane )
      {
        $error = 'message suspect.';
        foreach($intMWords as $strMKey=>$strMValue)
        {
        $error .= "- $strMValue";
        }
      }
    }

  }}

  // random keyboard
  if ( empty($error) && $strMVowel=='1' )
  {
    $iM=0;
    if ( !isset($arrMWords) ) $arrMWords = str_word_count($strM,1); // php 4.3.0
    foreach($arrMWords as $strMWord) {
    foreach(array('qwe','wqe','qsd','sdf','dfg','fgh','jkl','klm','ghg','fjf','jfj','fgf','dfd','fdj','dfj') as $aM) {
      if ( strpos($strMWord,$aM)===false ) continue;
      $iM++;
    }}
    if ( $iM>1 ) $error = 'message suspect.';
  }

  // END ANTISPAM

  // no error means: consecutive error reset to 0
  if ( empty($error) ) $_SESSION[QT]['m_antispam_count']=0;

  // watch for consecutive errors
  if ( !empty($error) ) {
  if ( $strMRepeat=='1' ) {
    $_SESSION[QT]['m_antispam_count']++;
    if ( $_SESSION[QT]['m_antispam_count']>3 )
    {
      // ban user 1 day
      if ( $oVIP->user->id!=1 ) $oDB->Query('UPDATE '.TABUSER.' SET closed="1" WHERE id='.$oVIP->user->id);
      $error = 'too many rejected messages today, retry tomorrow.';
    }
  }
  }

  if ( !empty($error) )
  {
  include Translate('qtfm_antispam.php');
  $error = $L['E_text'].'<br/>'.$L['antispam']['Says'].'<br/>'.$error.'<br/>';
  }

  // bypass if admin
  if ( !empty($error) && $oVIP->user->role=='A' )
  {
    $warning = $error;
    $error='';
  }
}